!Description:
!  ֹȤθĿʬ̤׻
!
! Current Code Owner: sugiyama@gfd-dennou.org
!
! History: 
!   Version    Date          Comment
!   -------    ----------    -------
!   1.0        2003-01-19    
!   1.1        2003-01-23    ҵ򸶻ֹѴ褦
!   1.2        2003-01-24    󥿡եʸޤ
!
! Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

!!!
!!!󥿡եʸ
!!!
module interface_atm2wt

  interface
     subroutine atm2wt(atmnum, enum, molwt)
       integer(8), intent(in)   :: atmnum(:)
       real(8), intent(in)      :: enum(:)
       real(8), intent(out)     :: molwt
     end subroutine atm2wt
  end interface

end module interface_atm2wt


!!!
!!!֥롼
!!!
subroutine atm2wt(atmnum, enum, molwt)
  use prm_chem, only: atmwt, amax
  implicit none
  
  integer(8), intent(in)   :: atmnum(:)
  real(8), intent(in)      :: enum(:)
  real(8), intent(out)     :: molwt

  real(8), allocatable     :: atmwt_tmp(:)
  integer(8)               :: M
  integer(8)               :: num
  

!!!
!!!ѿν
!!!
  M = size(atmnum, 1)
  allocate(atmwt_tmp(M))
  
  do num = 1, M
     atmwt_tmp(num) = atmwt(atmnum(num))
  end do
     
!!!
!!!ʬ̤η׻
!!!
  molwt = dot_product(atmwt_tmp, enum)
  
end subroutine atm2wt
