!c Description:
!c  ʪͤ鸵ֹ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-05    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_def_atmnum
  interface

     subroutine def_atmnum(property, atmnum)
       use prm_type, only: type_property, type_tree
       integer(8), intent(out), allocatable :: atmnum(:) 
       type(type_property), intent(in)      :: property(:)
     end subroutine def_atmnum

  end interface
end module interface_def_atmnum



subroutine def_atmnum(property, atmnum)
  use prm_type, only: type_property, type_tree
  use interface_binsort_store
  use interface_binsort_output
  use interface_list_output
  
  implicit none
  integer(8), intent(out), allocatable :: atmnum(:) 
  type(type_property), intent(in)      :: property(:)
  
  integer(8)                       :: s
  integer(8)                       :: N
  integer(8)                       :: e
  integer(8)                       :: atmnum_tmp(100)
  integer(8), allocatable          :: ivar(:)
  type(type_tree), pointer         :: root
  
  
  !
  nullify(root)
  N = size(property, 1)

  !ͤ
  do s = 1, N
     call list_output(property(s)%comps, atmnum=ivar)

     loop: do e = 1, size(ivar, 1)
        call binsort_store(root, ivar(e))
     end do loop
     
     deallocate(ivar)
  end do
  
  !ѿν
  atmnum_tmp = 0
  e = 0
  call binsort_output(root, e, atmnum_tmp)

  !ѿ
  allocate(atmnum(e))
  atmnum(1:e) = atmnum_tmp(1:e)
  
end subroutine Def_atmnum
