!Description:
!  ؼ̾ޤޤ븵̾ȤθĿȽꤹ
!
! Current Code Owner: sugiyama@gfd-dennou.org
!
! History: 
!   Version    Date          Comment
!   -------    ----------    -------
!   1.0        2003-01-19    
!   1.1        2003-01-23    ҵ򸶻ֹѴ褦
!   1.2        2003-01-24    󥿡եʸޤ
!
! Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

!!!
!!!󥿡եʸ
!!!
module interface_mol2atm
  interface
     subroutine mol2atm(sname, atmnum, enum)
       character(40), intent(in)            :: sname
       integer(8), allocatable, intent(out)    :: atmnum(:)
       real(8), allocatable, intent(out)    :: enum(:)
     end subroutine mol2atm
  end interface
end module interface_mol2atm


!!!
!!!֥롼ʸ
!!!
subroutine mol2atm(sname, atmnum, enum)
  use prm_chem, only: atmsymbol, amax

  implicit none
  character(40), intent(in)            :: sname
  integer(8), allocatable, intent(out)    :: atmnum(:)
  real(8), allocatable, intent(out)    :: enum(:)

  integer(8), allocatable       :: atmnum_tmp(:)
  real(8), allocatable       :: enum_tmp(:)
  integer(8), parameter      :: M = 20
  integer(8)                 :: num1, num2, num3
  character(2), allocatable  :: symbol(:)
  logical, allocatable       :: sw(:)


!!!
!!!ѿν
!!!
  allocate(atmnum_tmp(M), enum_tmp(M), symbol(M), sw(M))
  atmnum_tmp = 0
  enum_tmp = 0.0d0
  sw = .false. 
  num1 = 1
  num2 = 1


!!!
!!!̾Ȥο򲽳ؼ̾Ƚꤹ. 
!!!
  do num1 = 1, len_trim(sname)

     if (ichar('A') <= ichar(sname(num1:num1)) &
          & .AND. ichar(sname(num1:num1)) <= ichar('Z')) then 
        symbol(num2) = sname(num1:num1)
        enum_tmp(num2) = 1.0d0
        num2 = num2 + 1

     elseif (ichar('a') <= ichar(sname(num1:num1)) &
          & .AND. ichar(sname(num1:num1)) <= ichar('z')) then 
        symbol(num2-1) = sname(num1-1:num1)
        
     else
        symbol(num2-1) = sname(num1-1:num1-1)
        read(sname(num1:num1), *) enum_tmp(num2-1)  

     end if
  end do


!!!
!!!̾˽ʣʤȽ
!!!
  num3 = minloc(enum_tmp, 1) - 1
  sw(1: num3) = .true.

  do num1 = 1, num3 - 1
     do num2 = num1 + 1, num3
        
        if (symbol(num1) == symbol(num2)) then 
           enum_tmp(num1) = enum_tmp(num1) + enum_tmp(num2) 
           sw(num2) = .false. 
        end if

     end do
  end do


!!!
!!!̾鸶ֹ
!!!
  do num1 = 1, M 
     atm: do num2 = 1, amax
        if(symbol(num1) == atmsymbol(num2)) then 
           atmnum_tmp(num1) = num2
           exit atm
        end if
     end do atm
  end do


!!!
!!!Ѥѿ
!!!
  allocate(atmnum(count(sw)), enum(count(sw)))
  atmnum = pack(atmnum_tmp, sw)
  enum = pack(enum_tmp, sw)

end subroutine mol2atm
